#!/usr/bin/env python
# -*- coding: utf-8 -*-

# # Evoluation d'une population - énoncé
# 
# On souhaite ici faire évoluer une population à partir de table de mortalité et d'une situation initiale. Dans ce type d'exercice, on fait souvent un grand nombre de recherche internet pour trouver la fonction qui permet d'aller vite. Avec la pratique, on retient le nom de ces méthodes. La correction propose une solution mais il n'existe pas une façon unique de répondre à ces questions.

# In[1]:


from jyquickhelper import add_notebook_menu
add_notebook_menu()


# ### Introduction

# A partir de données récupérées sur Internet, on cherche à simuler l'évolution de la population française dans le futur. Par la suite, on pourra comparer différents scénarios en terme de natalité. Les données dont on dispose sont :
# 
# * [La pyramide des âges pour la France en 2017](https://www.insee.fr/fr/statistiques/2381472)
# * [Les tables de mortalités](https://www.ined.fr/fr/tout-savoir-population/chiffres/france/mortalite-cause-deces/table-mortalite/)
# * [Le taux de fécondité par âge](https://www.bdm.insee.fr/bdm2/affichageSeries?idbank=000436392&page=graphique&request_locale=fr)
# 
# Il existe d'autres sources comme [Eurostat](http://ec.europa.eu/eurostat/data/database). Les données sont mises à jour réuglièrement et les liens peuvent casser.
# Les exercices qui suivent requièrent les modules [pandas](http://pandas.pydata.org/), [numpy](http://www.numpy.org/), [matplotlib](http://matplotlib.org/). Voici quelques notebooks pour vous exercer :
# 
# * [DataFrame et Graphes](http://www.xavierdupre.fr/app/ensae_teaching_cs/helpsphinx/notebooks/td2a_cenonce_session_1.html) - [correction](http://www.xavierdupre.fr/app/ensae_teaching_cs/helpsphinx/notebooks/td2a_correction_session_1.html)
# * [Calcul Matriciel, Optimisation](http://www.xavierdupre.fr/app/ensae_teaching_cs/helpsphinx/td_2a.html) - [correction](http://www.xavierdupre.fr/app/ensae_teaching_cs/helpsphinx/notebooks/td2a_correction_session_2A.html)

# ### Exercice 1 : pyramides des âges
# 
# L'INED propose la [Pyramide des âges](https://www.ined.fr/fr/tout-savoir-population/chiffres/france/structure-population/pyramide-ages/) de la population française. Il faut reproduire ce graphique à partir des données mentionnées plus haut. Voici quelques liens qui pourraient vous y aider :
# 
# * Récupérer les données et les placer dans un [DataFrame](http://pandas.pydata.org/pandas-docs/stable/generated/pandas.DataFrame.html?highlight=dataframe) avec la fonction [read_csv](http://pandas.pydata.org/pandas-docs/stable/generated/pandas.read_csv.html?highlight=read#pandas.read_csv) ou [read_excel](http://pandas.pydata.org/pandas-docs/stable/generated/pandas.read_excel.html?highlight=read_excel#pandas.read_excel)
# * Tracer un graphique avec la fonction [plot](http://pandas.pydata.org/pandas-docs/stable/generated/pandas.DataFrame.plot.html?highlight=plot#pandas.DataFrame.plot)
# 
# Comme la pyramide des âges est un graphique spécifique mais assez courant, il est très probable qu'on trouve des bouts de codes sur Internet qui le proposent comme [Pyramide des ages](http://www.di.ens.fr/~vergnaud/teaching1415/TPc_20150304_Python.html).

# ### Exercice 2 : calcul de l'espérance de vie
# 
# Il faut calculer l'espérance vie à chaque âge à partir de la table de mortalité.

# ### Exercice 3 : simulation de la pyramide l'année suivante
# 
# On suppose qu'il n'y a pas de naissance, on calcule la population en janvier de cette année en appliquant les taux de mortalité de la table récupérée. On représente les deux pyramides sur le même graphique.

# ### Exercice 4 : simulation jusqu'en 2100
# 
# On suppose toujours qu'il n'y a pas de naissance. On continue la simulation jusqu'en 2100. On trace le même graphique avec cette nouvelle année.

# ### Exercice 5 : simulation avec les naissances
# 
# On reprend la même simulation mais on tient compte des naissances.

# In[2]: